# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取原始货单明细,32,32-32,sit,bs
主数据平台:后台运营系统获取原始货单明细接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import random
import requests
import json

module = "cmdc_32st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_102")
password = commonFuc().get_business_data(module, "password_102")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步电商配货列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url32_1")
request_body = commonFuc().get_business_data(module, "payload32_1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
super_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取配货信息信息
distributionCode = result["data"]["list"][super_random]["distributionCode"]
distributionCode = "17024537785107942-SO02"
# 第三步获取原始货单明细
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url32")
request_body = commonFuc().get_business_data(module, "payload32", distributionCode)
# print(request_body)
"""
 场景: 获取原始货单明细
 用例名称：获取原始货单明细
 输出：{"total":"%s"}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取原始货单明细
result = json.loads(result.content)

result = {"total": len(result["data"]["detailList"])}
# print(result)
# 将接口响应时间添加至result
result["api_time"] = api_time

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 查询数据库中对应配货单原始货单明细
sql = "SELECT count(t.distributionDetailId) FROM `cmdc-order`.tc_distribution_detail_org t " \
      "WHERE distributionCode = '{}'".format(distributionCode)
# print(sql)
total = mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict32", total)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)


