# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取购买合同,32,32-27,sit,bs
主数据平台:后台运营系统获取购买合同接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import random
import requests
import json

module = "cmdc_32st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_102")
password = commonFuc().get_business_data(module, "password_102")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步电商配货列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url_dis")
request_body = commonFuc().get_business_data(module, "payload_dis")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
super_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取配货信息信息
distributionId = result["data"]["list"][super_random]["distributionId"]

# 第三步获取配货信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url30")
request_body = commonFuc().get_business_data(module, "payload30", distributionId)
# 发送请求
result = requests.get(url, params=request_body, headers=headers)
result = json.loads(result.content)

# 获取配货单商品信息
companyCode = result["data"]["companyCode"]
customerCode = result["data"]["customerCode"]
productLineCode = result["data"]["productLineCode"]
product_list = []
for i in result["data"]["distributionDetailList"]:
    product_list.append(i["productCode"])
productCodes = ",".join(product_list)
# print(productCodes)
# 第四步获取购买合同
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url27")
request_body = commonFuc().get_business_data(module, "payload27", productCodes, companyCode, customerCode,
                                             productLineCode)

"""
 场景: 获取购买合同
 用例名称：获取购买合同
 输出：{"success":true,"code":"200","message":"OK"}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 将接口响应时间添加至result
result = json.loads(result.content)
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict27")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

