# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_商品包装管理,33,33-2,sit,be
主数据平台:后台运营系统获取商品包装管理列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_33st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取商品包装管理列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url1")
request_body = commonFuc().get_business_data(module, "payload1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
# 生成随机数
package_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取商品包装信息
materialCode = (result["data"]["list"][package_random]["materialCode"] if result["data"]["list"][package_random][
    "materialCode"] else "")
specifications = result["data"]["list"][package_random]["specifications"]
productCode = result["data"]["list"][package_random]["productCode"]
productName = result["data"]["list"][package_random]["productName"]

# 第三步进行列表条件查询
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url2")
request_body = commonFuc().get_business_data(module, "payload2", materialCode, specifications, productCode, productName)

"""

 场景: 列表查询条件验证_商品包装管理
 用例名称：列表查询条件验证_商品包装管理
 输出：{"productCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取商品包装信息
result = json.loads(result.content)
result = {"productCode": result["data"]["list"][0]["productCode"]}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict2", productCode)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
