# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc重复添加_新增站点开放白名单,2299,2299-24,sit,bs
主数据平台:后台运营系统获取站点开放白名单列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_area"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取站点开放白名单列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url12")
request_body = commonFuc().get_business_data(module, "payload12")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 判断开放白名单列表中是否有值
if result["data"]["list"]:
    # 生成随机数
    user_random = random.randint(0, len(result["data"]["list"]) - 1)
    # 获取白名单信息
    userName = result["data"]["list"][user_random]["userName"]


    # 第三步进行新增站点开放白名单
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url24")
    request_body = commonFuc().get_business_data(module, "payload24", userName)

    """
    
     场景: 重复添加_新增站点开放白名单
     用例名称：重复添加_新增站点开放白名单
     输出：{"success":false,"code":"siteopen","message":"用户白名单或申请已存在","data":null,"freshToken":null}
    """

    # 发送请求
    result = requests.post(url, json=request_body, headers=headers)
    # 获取接口响应时间
    api_time = float(result.elapsed.total_seconds())

    # 将接口响应时间添加至result
    result = json.loads(result.content)
    result["api_time"] = api_time

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict24")
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)

