# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc选赠促销导出功能验证,2262,2262-40,sit,bs
主数据平台:运营后台管理系统选赠促销导出接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import random
import json
import os


module = "cmdc_commodity_activity"


# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username30")
password = commonFuc().get_business_data(module, "password30")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步进行促销活动列表获取
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url40_1")
request_body = commonFuc().get_business_data(module, "payload40_1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
activity_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取促销活动信息
activityBasicId = result["data"]["list"][activity_random]["activityBasicId"]
activityName = result["data"]["list"][activity_random]["activityName"]
print(activityName)
# 第三步进行选赠活动信息导出
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url40")
request_body = commonFuc().get_business_data(module, "payload40", activityBasicId, activityBasicId)

"""
 场景:选赠促销导出功能验证
 用例名称：选赠促销导出功能验证
 输出：{"activityName": "%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = result.elapsed.total_seconds()

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/选赠活动列表.xlsx"

# 获取到导出文件存入cmdc_files文件中
with open(file_path, 'wb') as f:
    f.write(result.content)

# 获取导出文件中活动名称
excel = HandleExcel(file_path, "Sheet1")
result = {"activityName": excel.read_data()[0].get("活动名称")}

# 将接口响应时间添加至结果中
result["api_time"] = api_time


# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict40", activityName)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

