# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取商品详情信息,2252,2252-190,sit,bs
主数据平台:运营后台管理系统获取商品详情信息接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json


module = "cmdc_commodity_list"


# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username_102")
password = commonFuc().get_business_data(module, "password_102")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)
# 第二步获取商品信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url5_1")
request_body = commonFuc().get_business_data(module, "payload5_1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取商品信息
random_product = random.randint(0, len(result["data"]["list"]) - 1)
product_id = result["data"]["list"][random_product]["productId"]

# 第三步获取商品详情信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url5")
request_body = commonFuc().get_business_data(module, "payload5", product_id)

"""
 场景:获取商品详情信息
 用例名称：获取商品详情信息
 输出：{"productId":"%s"}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = result.elapsed.total_seconds()
result = json.loads(result.content)

# 获取商品详情信息
result = {"productId": result["data"]["productId"]}

# 将接口响应时间添加至result
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict5", product_id)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

