# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc重复添加_经销商宽限期添加,2298,2298-37,sit,bs
主数据平台:后台运营系统经销商宽限期添加接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_hospital"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取宽限期管理列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url21")
request_body = commonFuc().get_business_data(module, "payload21")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
grace_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取宽限期信息
productLineName = result["data"]["list"][grace_random]["productLineName"]
productLineCode = result["data"]["list"][grace_random]["productLineCode"]
graceMonth = result["data"]["list"][grace_random]["graceMonth"]
graceStage = result["data"]["list"][grace_random]["graceStage"]

# 第三步进行经销商宽限期添加
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url40")
request_body = commonFuc().get_business_data(module, "payload40", productLineName, productLineCode, graceMonth,
                                             graceStage)

"""

 场景: 重复添加_经销商宽限期添加
 用例名称：重复添加_经销商宽限期添加
 输出：{"success":false,"code":"5000","message":"与库中数据重复","data":null,"freshToken":null}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 将接口响应时间添加至result
result = json.loads(result.content)
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict40")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
