# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_返利信息列表,2300,2300-27,sit,be
主数据平台:后台运营系统获取返利信息列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_ls"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取返利信息列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url26")
request_body = commonFuc().get_business_data(module, "payload26")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

if result["data"]["list"]:
    # 生成随机数
    good_random = random.randint(0, len(result["data"]["list"]) - 1)
    # 获取返利信息
    goodsInfo = (
        result["data"]["list"][good_random]["customerCode"] if result["data"]["list"][good_random]["customerCode"] else "")
    statisticQuarter = result["data"]["list"][good_random]["statisticQuarter"]
    statisticYear = result["data"]["list"][good_random]["statisticYear"]

    # 第三步进行列表条件查询
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url27")
    request_body = commonFuc().get_business_data(module, "payload27", goodsInfo, statisticQuarter, statisticYear)
    """
    
     场景: 列表查询条件验证_返利信息列表
     用例名称：列表查询条件验证_返利信息列表
     输出：{"statisticQuarter":"%s"}
    """

    # 发送请求
    result = requests.post(url, json=request_body, headers=headers)
    # 获取接口响应时间
    api_time = float(result.elapsed.total_seconds())

    # 获取返利信息
    result = json.loads(result.content)
    result = {"statisticQuarter": result["data"]["list"][0]["statisticQuarter"]}
    # print(result)

    # 将接口响应时间添加至result
    result["api_time"] = api_time

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict27", statisticQuarter)
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
