# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc电商配货中接口验证,2295,2295-126,sit,bs
主数据平台:后台运营系统电商配货中接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取配货单列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url126_1")
request_body = commonFuc().get_business_data(module, "payload126_1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
dis_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取配货单信息
distributionId = result["data"]["list"][dis_random]["distributionId"]

# 第三步电商配货中接口验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url126")
request_body = commonFuc().get_business_data(module, "payload126", distributionId)

"""

 场景: 电商配货中接口验证
 用例名称：电商配货中接口验证
 输出：{"distributionId":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取配货页面信息
result = json.loads(result.content)
result = {"distributionId": result["data"]["distributionId"]}
# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict126", distributionId)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
