# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取已配置的植入产品线信息,00,00-84,sit,bs
主数据平台:后台运营系统获取已配置的植入产品线信息接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import json

module = "cmdc_special_version"

# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username_uat")
password = commonFuc().get_business_data(module, "password_uat")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 获取已配置的植入产品线信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url83")
request_body = commonFuc().get_business_data(module, "payload83")

"""
 场景: 获取已配置的植入产品线信息
 用例名称：获取已配置的植入产品线信息
 输出：{"total":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)

# 获取产品线数量
result = {"total": result["data"]["total"]}
result["api_time"] = api_time
# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 数据库配置限购金额商品数量
sql = "SELECT count(1) FROM `cmdc-order`.tc_report_productline t WHERE companyCode = '00102'"
total = (mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]
         if mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql) else 0)

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict83", total)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
