# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc查询条件验证_发货单物流信息列表,2294,2294-12,sit,bs
主数据平台:多采商城获取发货单物流信息列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.多采商城登录.多采商城登录 import CmdcMaiiLogin
import datetime
import random
import requests
import json

module = "cmdc_trade"

# 第一步获取登录多采商城所需账号密码
username = commonFuc().get_business_data(module, "username3")
password = commonFuc().get_business_data(module, "password3")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcMaiiLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 第二步获取发货单物流信息列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url11")
request_body = commonFuc().get_business_data(module, "payload11")
# 发送请求
result = requests.get(url, params=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
jde_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取发货单信息
seller_company_code = result["data"]["list"][jde_random]["sellerCompanyCode"]
demand_parent_code = result["data"]["list"][jde_random]["demandParentCode"]
demand_code = result["data"]["list"][jde_random]["demandCode"]
sd_random = random.randint(0, len(result["data"]["list"][jde_random]["SDDOCOList"]) - 1)
sddoco_1 = result["data"]["list"][jde_random]["SDDOCOList"][sd_random][:8]
start_time = result["data"]["list"][jde_random]["createTime"]
end_time = datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")

# 第三步获取发货单详情信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url13")
request_body = commonFuc().get_business_data(module, "payload13", demand_parent_code)
# 发送请求
result = requests.get(url, params=request_body, headers=headers)
result = json.loads(result.content)

# 获取商品信息
product_code = result["data"]["detail"][0]["list"][0]["productCode"]
option_str = result["data"]["detail"][0]["list"][0]["optionStr"]

# 第四步进行查询条件验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url12")
request_body = commonFuc().get_business_data(module, "payload12", demand_parent_code, product_code, end_time,
                                             start_time, end_time, start_time,
                                             demand_code, sddoco_1, option_str)

"""

 场景: 查询条件验证_发货单物流信息列表
 用例名称：查询条件验证_发货单物流信息列表
 输出：{"demandParentCode":"%s"}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)
# print(result)
# 获取查询结果中demandParentCode
result = {"demandParentCode": result["data"]["list"][0]["demandParentCode"]}

# 将获取到的响应时间添加至result
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict12", demand_parent_code)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
