# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc查询条件验证_退货单管理,2294,2294-24,sit,bs
主数据平台:多采商城获取退货单列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import datetime
import random
import json

module = "cmdc_trade"

# 第一步登录后台运营系统获取toen信息
username = commonFuc().get_business_data(module, "username4")
password = commonFuc().get_business_data(module, "password4")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取退货单管理列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url22")
request_body = commonFuc().get_business_data(module, "payload22")
# 发送请求
result = requests.get(url, params=request_body, headers=headers)
result = json.loads(result.content)

# 判断是否获取到退货单信息
if result["data"]["list"]:
    # 生成随机数
    code_random = random.randint(0, len(result["data"]["list"]) - 1)
    # 获取退货单信息
    jde_refund_code = result["data"]["list"][code_random]["jdeRefundCode"]
    customer_name = result["data"]["list"][code_random]["customerName"]
    manufacturer = result["data"]["list"][code_random]["manufacturer"]
    material_code = result["data"]["list"][code_random]["materialCode"]
    demand_parent_code = result["data"]["list"][code_random]["demandParentCode"]
    start_time = result["data"]["list"][code_random]["submitTime"]
    end_time = datetime.datetime.now().strftime("%Y-%m-%d")

    # 第三步获取退货单详情
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url23")
    request_body = commonFuc().get_business_data(module, "payload23", jde_refund_code,
                                                 customer_name, manufacturer, material_code, demand_parent_code, start_time,
                                                 end_time)

    """
    
     场景: 查询条件验证_退货单管理
     用例名称：查询条件验证_退货单管理
     输出：{"jdeRefundCode":"%s"}
    """

    # 发送请求
    result = requests.get(url, params=request_body, headers=headers)
    # 获取接口响应时间
    api_time = float(result.elapsed.total_seconds())

    # 获取详情页中的jdeRefundCode
    result = json.loads(result.content)
    result = {"jdeRefundCode": result["data"]["list"][0]["jdeRefundCode"]}

    # 将接口响应时间添加到result
    result["api_time"] = api_time
    # print(result)

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict23", jde_refund_code)
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
