# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取站点jde配货手动推送设置信息,2256,2256-21,sit,bs
主数据平台:后台运营系统获取站点jde配货手动推送设置信息接口 
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import random
import json

module = "cmdc_website"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username")
password = commonFuc().get_business_data(module, "password")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 第二步获取站点列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url4")
request_body = commonFuc().get_business_data(module, "payload4")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 判断是否获取到站点信息
if result["data"]["list"]:
    # 生成随机数
    website_random = random.randint(0, len(result["data"]["list"]) - 1)
    # 获取站点信息
    companyId = result["data"]["list"][website_random]["companyId"]

    # 第三步获取站点jde配货手动推送设置信息
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url21")
    request_body = commonFuc().get_business_data(module, "payload21", companyId)
    """
    
     场景: 获取站点jde配货手动推送设置信息
     用例名称：获取站点jde配货手动推送设置信息
     输出：{"total":"%s"}
    """

    # 发送请求
    result = requests.post(url, json=request_body, headers=headers)
    # 获取接口响应时间
    api_time = float(result.elapsed.total_seconds())

    # 获取站点JDE配货手动推送设置信息
    result = json.loads(result.content)
    # print(result)
    result = {"total": len(result["data"]) if result["data"] else 0}

    # 将接口响应时间添加至result
    result["api_time"] = api_time

    # 数据库操作
    mysql_handle = mySql()
    # 获取conf.ini文件中配置的数据库信息
    host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

    # 查询数据库中站点JDE配货手动推送设置
    sql = "SELECT count(t.id) FROM `cmdc-order`.tc_jde_push_config t " \
          "WHERE companyCode in (SELECT t.companyCode FROM `cmdc-user`.cmdc_company t WHERE companyId = {})".format(
        companyId)
    total = mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict21", total)
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
